procedure _outputFile.create( filename : string );
var f : file;
    c : char;
begin
  outputFile.opened := false;
  outputFile.bytes := 0;

  { testen, ob die Datei bereits existiert }
  assign( f , filename );
  reset( f , 1 );
  if ioresult = 0 then
  begin
    close( f );
    if outputFile.overwrite = ask then
    begin
      writeln('   file '''+filename+''' already exists. ');
      write  ('    Overwrite ([Y]es,[S]kip,[A]lways,[N]ever,[Q]uit)?');
      c := ' ';
      while (c<>'Y') and (c<>'N') and (c<>'A') and (c<>'Q') and (c<>'S') do
      begin
        c := readkey;
        if (byte(c) >= byte('a')) and (byte(c) <= byte('z')) then c:=char(byte(c)-32);
      end;
      writeln;
      outputFile.overwrite := ask;
      if c='A' then outputFile.overwrite := always;
      if c='N' then outputFile.overwrite := never;
      if c='S' then exit;
      if c='Q' then quit;
    end;
    if outputFile.overwrite = never then
    begin
      writeln('    (skipped)');
      exit;
    end;
  end;

  assign( outputFile.handle , outputFile.name );
  rewrite( outputFile.handle , 1 );
  if ioresult <> 0 then error( 6 );
  outputFile.opened := true;
end;

procedure _outputFile._write;
begin
  blockwrite( outputFile.handle , outputFile.Buf^ , outputFile.BufPtr );
  if ioresult <> 0 then error( 7 );
  inc( outputFile.bytes , outputFile.bufPtr );
  outputFile.BufPtr := 0;
end;

procedure _outputFile._close;
var _df : string;
    df  : longint;
begin
  if outputFile.opened then
  begin
    df := diskFree(0);
    str( df , _df );
    writeln('   binary-file '''+outputFile.name+''' created. ',outputFile.bytes,' byte written. ',_df,' byte free.');
    inc( filesCounter );
    bytesCounter := bytesCounter + outputFile.bytes;
    outputFile.opened := false;
    close( outputFile.handle );
    if ioresult <> 0 then error( 4 );
  end;
end;

