Function FileExists( filename : string ) : Boolean;
var f : file;
    io : integer;
begin
    {$I-}
    fileExists := False;
    assign( f , filename );
    reset( f , 1 );
    IO := Ioresult;
    if io = 0 then
    begin
        FileExists := True;
        close(f);
    end;
    {$I+}
end;

procedure main;
var buffer : string;
    filesDone : byte;
    i : byte;
    index : byte;
    linelength : byte;
    nbr : byte;
    blocks : byte;
    ebyte1 : byte;
    ebyte2 : byte;
    ebyte3 : byte;
    ebyte4 : byte;
    j      : word;
    buf    : string;
label
  done;
begin
  if memAvail < sizeof(byteArray) then error( 5 );
  getmem( outputFile.buf , sizeof(byteArray) );

  repeat

    { den Beginn des ersten / des nchsten Binrblockes suchen }
    buffer := '';
    while (copy(buffer , 1 , 5 ) <> 'begin') and (not eof(mainFile.handle)) do
      readln( mainFile.handle , buffer );

    { den Originalnamen extrahieren und den Dateinamen anlegen }
    if not eof(mainFile.handle) then
    begin
      for i := byte(buffer[0]) downto 1 do
        if buffer[i] = ' ' then
        begin
          outputFile.name := copy( buffer , succ(i) , 255 );
          break;
      end;
      writeln('   found binary file '''+outputFile.name+'''.');
      If byte(outputFile.name[0]) > 12 then
      begin
          j := 0;
          repeat
              str( j , buf );
              If Not FileExists( buf )
                  then outputFile.name := buf
                  else inc(j);
          until byte(outputFile.name[0]) <= 12;
          writeln('   Cutting long filename! Shorting filename to '''+outputFile.name+'''...' );
      end;
      outputFile.create( outputFile.name );

      if outputFile.opened then
      begin

        outputFile.BufPtr := 0;
        repeat
          readln( mainFile.handle , buffer );
          if (not (buffer='end')) and (not (buffer='`')) and (not eof(mainFile.handle)) then
          begin

            linelength := byte(buffer[1]) - $20;
            blocks := linelength div 3; if (linelength mod 3) > 0 then inc(blocks);
            index := 2;
            if blocks > 0 then for nbr := 1 to blocks do
            begin
              ebyte1 := (byte( buffer[ index ] ) - $20) and $3F;
              ebyte2 := (byte( buffer[ index+1 ] ) - $20) and $3F;
              ebyte3 := (byte( buffer[ index+2 ] ) - $20) and $3F;
              ebyte4 := (byte( buffer[ index+3 ] ) - $20) and $3F;
              inc( index , 4 );

              outputFile.buf^[ outputFile.bufPtr ] := ((ebyte1 ) shl 2) + ((ebyte2 and $30) shr 4);;
              inc( outputFile.bufPtr);
              if outputFile.bufPtr = outputBufferSize then outputFile._write;
              dec( lineLength );
              if lineLength = 0 then goto done;

              outputFile.buf^[ outputFile.bufPtr ] := ((ebyte2 and $F) shl 4) + ((ebyte3 and $3C) shr 2);;
              inc( outputFile.bufPtr);
              if outputFile.bufPtr = outputBufferSize then outputFile._write;
              dec( lineLength );
              if lineLength = 0 then goto done;

              outputFile.buf^[ outputFile.bufPtr ] := ((ebyte3 and $3) shl 6) + ((ebyte4) );
              inc( outputFile.bufPtr);
              if outputFile.bufPtr = outputBufferSize then outputFile._write;
              dec( lineLength );

            done:

            end;
          end;
        until (copy( buffer , 1 , 3 ) = 'end') or (buffer = '`') or (eof(mainFile.handle));
        outputFile._write;
        outputFile._close;

      end;
    end;

    { wurde ESC gedrckt? }
    if keypressed then
    begin
      if readkey = #27 then error( 8 );
    end;

  until eof( mainFile.handle );

  freemem( outputFile.buf , sizeof(byteArray) );
end;


